// UTILITY FUNCTIONS

var to_confirm_lock_keys = [];
var confirmed_lock_keys = [];

var bpt_uri_prefix = "";

function BPT_URIForImage( what ) {

	return bpt_uri_prefix + what;

}

function IsRunningInsideCallbackHost() {
	return ( (undefined != window["s3e"]) || 
		(undefined != window["js_to_sputm_callback"]) );
}

var stateThatTriggeredOptions = undefined;
var stateThatTriggeredMore = undefined;
var on_confirm_yes_send_msg = undefined;
var msg_that_triggered_confirm = undefined;
var host_state_simulation = [];

function HostCheckSimulation( context ) {

	if ( !IsRunningInsideCallbackHost() ) {
		if ( !host_state_simulation.hasOwnProperty( context ) ) host_state_simulation[ context ] = false;
		host_state_simulation[ context ] = !host_state_simulation[ context ];
		SetContextInformation( context, host_state_simulation[ context ]);
		
		//app.makeToast(context,host_state_simulation[ context ]);
	}
}

function NimbusGames_send_host_message( msg ) {
	
	// action logic that doesn't require host
	
	switch ( msg ) {
	
	case 'status=menu_has_been_kickstarted':
		if ( !IsRunningInsideCallbackHost() ) {
			//TESTING_PC(false);
			TESTING_iOS(true);
		}
		
		setTimeout(
			function() {
				ChangeState("_splash");
				setTimeout( function() {
					ChangeState("_splash2");
					setTimeout( function() {
						ChangeState("_menu");
					}, 2000 );
				}, 2000 );
				ChangeLoadedStateForThese( $('#container') , true, '._preload_' );
			}, 1000 );
		
		break;
		
	/* simulate host in not in the host... */
		
	case 'action=op_skip':
		if ( !IsRunningInsideCallbackHost() ) HostCheckSimulation( '_skip' );
		break;
		
	case 'action=op_text':
		if ( !IsRunningInsideCallbackHost() ) HostCheckSimulation( '_text' );
		break;
		
	case 'action=op_music':
		if ( !IsRunningInsideCallbackHost() ) HostCheckSimulation( '_music' );
		break;
	
	case 'action=op_disable_iap':
	case 'action=pw_disable_iap':
		if ( !IsRunningInsideCallbackHost() ) {
			HostCheckSimulation( '_disable_iap' );
			SetContextInformation( '_iap_enabled', !host_state_simulation[ '_disable_iap' ]);
			//SetContextAsDisabled( '_iap_enabled', host_state_simulation[ '_disable_iap' ]);
		}
		break;

	/* end checkbox host simulation */
		
	case 'action=op_restart':
		ChangeState("_restart");
		break;

	case 'action=op_restart':
		ChangeState("_restart");
		break;

	case 'action=op_nimbus_logo_privacy_policy':
		ChangeState("_privacy");
		break;

	case 'action=pp_home':
		ChangeState("_options");
		break;
		
	case 'action=mm_options':
	case 'action=pm_options':
	case 'action=pc_menu_options':
		ChangeState("_options");
		stateThatTriggeredOptions = lastActiveState;
		break;
		
	case 'action=op_restore_purchase':
	case 'action=mm_unlock_now':
		ChangeState("_paywall");
		break;
		
	case 'action=restart_no':
		ChangeState("_options");
		break;

	case 'action=help_home':
		if ( '_toc_elements' == activeState ) {
			ChangeState("_options");
		} else {
			ChangeState("_toc_elements");
		}
		break;
		
	case 'action=toc_game_start_section':
		ChangeState("_1_1_elements");
		break;

	case 'action=toc_kenya_section':
		ChangeState("_2_1_elements");
		break;
		
	case 'action=toc_jambo_section':
		ChangeState("_3_1_elements");
		break;
		
	case 'action=toc_skeeter_section':
		ChangeState("_4_1_elements");
		break;
		
	case 'action=toc_zanzibar_section':
		ChangeState("_5_1_elements");
		break;
		
	case 'action=toc_masai_section':
		ChangeState("_6_1_elements");
		break;
		
	case 'action=toc_sammy_section':
		ChangeState("_7_1_elements");
		break;
		
	case 'action=op_help': // this only happens when validated by the game
		if ( !IsRunningInsideCallbackHost() ) {
			ChangeState("_toc_elements");
		}
		break;
	
	case 'action=op_home':
		if ( undefined != stateThatTriggeredOptions ) {
			ChangeState(stateThatTriggeredOptions);
		} else {
			ChangeState("_menu");
		}
		break;
		
	case 'action=ri_home':
	case 'action=pw_home':
	case 'action=restart_yes':
	//     app.makeToast("reset",true);

    case 'action=pm_main_menu':
		ChangeState("_menu");
		break;

	case 'action=zoom_back':
	case 'action=zoom_center':
	case 'action=zoom_right':
	case 'action=zoom_left':
		if ( "_rate_it" == lastActiveState ) {
			ChangeState("_rate_it");
		} else {
			ChangeState("_paywall");
		}
		break;
		
	case 'action=thumbnail_left':
		ChangeState("_zoom_left");
		break;
		
	case 'action=thumbnail_center':
		ChangeState("_zoom_center");
		break;
		
	case 'action=thumbnail_right':
		ChangeState("_zoom_right");
		break;
		
	case 'action=help_prev':
		ChangeState( PrevHelpPageFrom(activeState) );
		break;
		
	case 'action=help_next':
		ChangeState( NextHelpPageFrom(activeState) );
		break;
		
	case 'action=up_home':
	case 'action=up_homepj1':
	case 'action=up_homeff1':
	case 'action=up_homeff2':
	case 'action=up_homepp1':
	case 'action=up_homepp2':
	case 'action=up_homesf1':
	
		//ChangeState( lastActiveState );
		ChangeState("_menu");
		break;
		
	case 'action=mm_more':
	case 'action=op_more':
		//stateThatTriggeredMore = activeState;
		//ChangeState("_upsell");
	
	    stateThatTriggeredMore = activeState;
	 	ChangeState("_upsellpj1");
		break;


	case 'action=confirm_key_gfx_0':
	case 'action=confirm_key_gfx_9':
	case 'action=confirm_key_gfx_8':
	case 'action=confirm_key_gfx_7':
	case 'action=confirm_key_gfx_6':
	case 'action=confirm_key_gfx_5':
	case 'action=confirm_key_gfx_4':
	case 'action=confirm_key_gfx_3':
	case 'action=confirm_key_gfx_2':
	case 'action=confirm_key_gfx_1':
	
		var found = to_confirm_lock_keys.indexOf( msg );
		
		if ( -1 == found ) {
		
			if ( -1 == confirmed_lock_keys.indexOf( msg ) ) {
		
				NimbusGames_send_host_message( 'action=confirm_no' );
				
				msg = undefined; // stomp on the message that triggered the new redirected msg
				
			}
		
		} else {
		
			$( "#" + msg.slice(7) ).removeClass( "confirm_key_available" ).addClass( "confirm_key_selected" );
		
			confirmed_lock_keys = confirmed_lock_keys.concat(
				confirmed_lock_keys, to_confirm_lock_keys.splice( found, 1 ) );
			
			if ( 0 == to_confirm_lock_keys.length ) {
			   
				NimbusGames_send_host_message( 'action=confirm_yes' );
				
				msg = undefined; // stomp on the message that triggered the new redirected msg
				
			}
		
		}
	
		break;
	case 'action=up_pppj_bottom':
	case 'action=up_ppsf_bottom':
	case 'action=up_ppff1_bottom':
	case 'action=up_ppff2_bottom':
	case  'action=up_pp2left_icon':
		ChangeState("_upsellpp1");
		break;
	case 'action=up_pp1right_icon':	
	    ChangeState("_upsellpp2");
		break;
	case 'action=up_pjpp1_bottom':
	case 'action=up_pjpp2_bottom':
	case 'action=up_pjff1_bottom':
	case 'action=up_pjff2_bottom':
	case 'action=up_pjsf_bottom':
	    ChangeState("_upsellpj1");
		break;
	case 'action=up_ffpj_bottom':
	case 'action=up_ffpp1_bottom':
	case 'action=up_ffpp2_bottom':
	case 'action=up_ffsf_bottom':
	case 'action=up_ff2left_icon':
	    ChangeState("_upsellff1");
		break;
	case 'action=up_ff1right_icon':
		ChangeState("_upsellff2");		
		break;
	case 'action=up_sfpj_bottom':
	case 'action=up_sfpp1_bottom':
	case 'action=up_sfpp2_bottom':
	case 'action=up_sfff1_bottom':
	case 'action=up_sfff2_bottom':
		    ChangeState("_upsellsf1");
		break;
	
	case 'action=mm_like':
	case 'action=up_pp1_icon':
	case 'action=up_pp2_icon':
	case 'action=up_pp3_icon':
	case 'action=up_pp4_icon':
	case 'action=up_pp5_icon':
	case 'action=up_pp6_icon':
	//case 'action=up_pp_bottom':
	case 'action=up_ff1_icon':
	case 'action=up_ff2_icon':
	case 'action=up_ff3_icon':
	case 'action=up_ff4_icon':
	case 'action=up_ff5_icon':
	case 'action=up_ffm1_icon':
	//case 'action=up_ff_bottom':
	case 'action=up_pj1_icon':
	case 'action=up_pj2_icon':
	case 'action=up_pj3_icon':
	//case 'action=up_pj_bottom':
	case 'action=up_sf1_icon':
	case 'action=up_sf2_icon':
	case 'action=up_sf3_icon':
	//case 'action=up_sf_bottom':
	case 'action=up_nimbus_logo':
	case 'action=pw_already_purchased':
	case 'action=pw_unlock_now':
		/* testing out of host */
		
		try
		{
			if ( undefined == upsell_action_to_url_table ) {
				upsell_action_to_url_table = [];
			}
		}
		catch(e)
		{
			upsell_action_to_url_table = [];
		}
		if ( !upsell_action_to_url_table.hasOwnProperty( msg ) ) {
			upsell_action_to_url_table[ msg ] = 'warning=' + msg;
		}
		/* normal */
		if ( upsell_action_to_url_table.hasOwnProperty( msg ) ) {
			msg_that_triggered_confirm = msg;
			//on_confirm_yes_send_msg = 'launch=' + upsell_action_to_url_table[ msg ];
			on_confirm_yes_send_msg = upsell_action_to_url_table[msg];
			
			ChangeState( "_confirm" );
			//var win=window.open(upsell_action_to_url_talb[msg],'_system');
		}
		break;

	case 'action=confirm_yes':
	
		//alert("HI"+msg_that_triggered_confirm);
		if ( 'action=mm_like' != msg_that_triggered_confirm ) {
	
			// this is exactly why I need to make a real stack for these contexts!!!!
		
			if ( ('action=pw_unlock_now' == msg_that_triggered_confirm) || 
				('action=pw_already_purchased' == msg_that_triggered_confirm) ) {
			
				ChangeState("_paywall");
				lastActiveState = "_menu";
				
			} else {
			
				ChangeState("_upsellpj1");
				lastActiveState = (undefined != stateThatTriggeredMore) ? stateThatTriggeredMore : "_menu";
				
			}
			
		} else {
		
			ChangeState("_menu");
			NimbusGames_send_host_message('action=ri_rate_it_now');
		
		}
		msg = on_confirm_yes_send_msg;
		var win=window.open(msg,'_system');
		break;
		
	case 'action=confirm_no':
		if ( 'action=mm_like' != msg_that_triggered_confirm ) {
		
			// this is exactly why I need to make a real stack for these contexts!!!!
		
			if ( ('action=pw_unlock_now' == msg_that_triggered_confirm) || 
				('action=pw_already_purchased' == msg_that_triggered_confirm) ) {
			
				ChangeState("_paywall");
				lastActiveState = "_menu";
				
			} else {
	
				ChangeState("_upsellpj1");
				lastActiveState = (undefined != stateThatTriggeredMore) ? stateThatTriggeredMore : "_menu";
				
			}
			
		} else {
		
			ChangeState("_menu");
		
		}
		break;
		
	}
	
	if ( undefined != msg ) {
	
		var sent_msg = false;
		
		
		if ( undefined != window["s3e"] ) {
		
		//	var win=window.open(msg,'_system');
			s3e.exec( msg );
			sent_msg = true;
			
		}
		
		if ( undefined != window["js_to_sputm_callback"] ) {
		
			js_to_sputm_callback( msg );
			sent_msg = true;
		
		}
		
		if ( !sent_msg) { ChangeMsg( msg ); }
		
	}
	
} 

// STATE INDICATOR

var lastMsg = "";

function ClearMsg() {
    lastMsg = ""
    var e = document.getElementById('msg');
	if ( null != e ) e.innerHTML = "";
}

function ChangeMsg(msg) {
	if ( lastMsg != msg ) {
	    var e = document.getElementById('msg');
	    if (null != e) {
            //FIXME: SAMRET REMOVE
	 //       e.innerHTML =
	//		    "<div id='msg_holder'><div id='msg_indicator'>" + msg + "</div></div>";
	    }
		lastMsg = msg;
	}
}

function AppendMsg(msg) {
	ChangeMsg( lastMsg + msg );
}

// ANIM MANAGEMENT

function CycleThroughArray( frames ) {

	var f = -1;

	return function() {
	
		return frames[ f = ((++f >= frames.length) ? 0 : f) ];
	
	}
	
}

function AnimateVisibility( frames ) {

	var i;
	
	for ( i in frames ) {
	
		SetItemVisibility( frames[i], 'hidden' );
	
	}

	var nextFN = CycleThroughArray( frames );
	
	var prev = undefined;
	
	return function() {
	
		if ( undefined != prev ) SetItemVisibility( prev, 'hidden' );
		
		prev = nextFN(); 
		
		SetItemVisibility( prev, 'visible' );
	
	}

}

// animation controller

var active_animations = {}
var inactive_animations = {}

function ActivateAnimation( frames, bStart ) {

	if ( inactive_animations.hasOwnProperty( frames ) ) {
	
		if ( bStart ) {
		
			active_animations[ frames ] = inactive_animations[ frames ];
		
			delete inactive_animations[ frames ];
			
			return;
		
		}
		
	}

	if ( active_animations.hasOwnProperty( frames ) ) {
	
		if ( bStart ) return;

		inactive_animations[ frames ] = active_animations[ frames ];
	
		delete active_animations[ frames ];
		
	}
	
	if ( bStart ) {

		active_animations[ frames ] = AnimateVisibility( frames );
		
	}

}

function PerformAnimations() {

	for ( var i in active_animations ) {
	
		active_animations[i]();
	
	}

}

// STATE MANAGEMENT

var lastActiveState = "";
var activeState = "";
var lastAction = ""; //FIXME: SAMRET FIX
var restart_y_head_animation_frames = [ "y_frame_01", "y_frame_02", "y_frame_03", "y_frame_04" ];
var restart_n_head_animation_frames = [ "n_frame_01", "n_frame_02", "n_frame_03", "n_frame_04" ];
var m1_butterfly_frames = [];
var m2_butterfly_frames = [];
var pm_butterfly_frames = [];
var ri_butterfly_frames = [];
var pw_butterfly_frames = [];
var pc_butterfly_frames = [];

var stateInfo = {

	"_menu":{ divs:[ "menu_elements" ], items:[ "menu_elements" ] }
,	"_pc_menu":{ divs:[ "menu_elements" ], items:[ "menu_elements" ] }
,	"_pause":{ divs:[ "menu_elements" ], items:[ "menu_elements" ] }
,	"_options":{ divs:[ "options_elements" ], items:[ "options_elements" ] }
,	"_upsell":{ divs:[ "upsell_elements" ], items:[ "upsell_elements" ] }
,	"_splash":{ divs:[ "splash_elements" ], items:[ "splash_elements" ]}
,	"_splash2":{ divs:[ "splash2_elements" ], items:[ "splash2_elements" ]}
,	"_confirm":{ divs:[ "confirm_elements" ], items:[ "confirm_elements" ], beforevisiblefn:open_confirm_lock }
,	"_restart":{ divs:[ "restart_elements" ], items:[ "restart_elements" ], anims:[ restart_y_head_animation_frames, restart_n_head_animation_frames ] }
,	"_paywall":{ divs:[ "paywall_elements" ], items:[ "paywall_elements" ]}
,	"_privacy":{ divs:[ "privacy_elements" ], items:[ "privacy_elements" ]}
// Modify UpSell
,	"_upsellpj1":{ divs:[ "upsellpj1_elements" ], items:[ "upsellpj1_elements" ] }
,	"_upsellpp1":{ divs:[ "upsellpp1_elements" ], items:[ "upsellpp1_elements" ] }
,	"_upsellpp2":{ divs:[ "upsellpp2_elements" ], items:[ "upsellpp2_elements" ] }
,	"_upsellsf1":{ divs:[ "upsellsf1_elements" ], items:[ "upsellsf1_elements" ] }
,	"_upsellff1":{ divs:[ "upsellff1_elements" ], items:[ "upsellff1_elements" ] }
,	"_upsellff2":{ divs:[ "upsellff2_elements" ], items:[ "upsellff2_elements" ] }

};

// --------------------------------------------------------

function open_confirm_lock() {
   // alert('ae');
	var available_picks = [1,2,3,4,5,6,7,8,9];

	for ( var j = 0; j <= 9; ++j ) {
	
		$( "#confirm_key_gfx_" + j ).removeClass( "confirm_key_selected" ).addClass( "confirm_key_available" );
	
	}
	
	to_confirm_lock_keys = [];
	confirmed_lock_keys = [];
	
	var time = 1;
	
	for ( var i = 1; i <= 2; ++i ) {
	
		var n = Math.floor((Math.random()*(available_picks.length))+1) - 1; // [0 to length)
		
		var pick = available_picks[n];
		
		available_picks.splice(n,1);
		
		$( "#confirm_lock_pos_" + i ).attr( 'src', "img/confirm_lock_gfx_" + pick + ".png" );
		
		
		time *= pick; // add
		
		//to_confirm_lock_keys.push( "action=confirm_key_gfx_" + pick );
	
	}
	
	to_confirm_lock_keys.push( "action=confirm_key_gfx_" + Math.floor(time/10) );
	to_confirm_lock_keys.push( "action=confirm_key_gfx_" + (time%10) );
	
	

}

// --------------------------------------------------------

function SetItemVisibility( id, vis ) {

	var e = $( document.getElementById( id ) );
	
	var bVisible = ('visible' == vis);
	
	if ( $.ui ) {
	
		e.switchClass(
			bVisible ? 'bpt_hidden_item' : 'bpt_visible_item',
			bVisible ? 'bpt_visible_item' : 'bpt_hidden_item', 0,
			function() {
				ChangeLoadedStateForThese( e, bVisible );
			});
			
; // load/unload assets

	} else {
	
		e	.removeClass( bVisible ? 'bpt_hidden_item' : 'bpt_visible_item')
			.addClass( bVisible ? 'bpt_visible_item' : 'bpt_hidden_item' );
		
		ChangeLoadedStateForThese( e, bVisible );

	}
	
}

function SetElementsVisibility( id, vis ) {

	var e = $( document.getElementById( id ) );
	
	var bVisible = ('visible' == vis);
	
	if ( $.ui ) {
	
		e.switchClass(
			bVisible ? 'bpt_hidden_elements' : 'bpt_visible_elements',
			bVisible ? 'bpt_visible_elements' : 'bpt_hidden_elements', 0 );
			
; // load/unload assets

	} else {
	
		e	.removeClass( bVisible ? 'bpt_hidden_elements' : 'bpt_visible_elements')
			.addClass( bVisible ? 'bpt_visible_elements' : 'bpt_hidden_elements' );
			
	}

}

// --------------------------------------------------------

function ChangeLoadedStateForThese( sel, bLoad, classes ) {

	if ( undefined == classes ) classes = '';

	$('img._src_' + classes,$(sel)).each( function( i, img ) {
	
		img = $(img);
	
		if ( bLoad ) {
		
			img.attr( 'src', BPT_URIForImage(img.attr('_src_')) );
			
			if ( img.hasClass( '_keep_' ) || img.hasClass( '_preload_' )) {
			
				img.removeClass( '_src_' ); // once this is loaded it stays loaded...
			
			}
			
		} else {

			img.attr( 'src', BPT_URIForImage('zzz.gif') );
			
		}
		
	});
	
}

function ChangeLoadedStateForImgsWithin( who, bLoad ) {

	ChangeLoadedStateForThese( $(who), bLoad );
	
}

// --------------------------------------------------------

function SetStateVisibility( state, vis ) {

	var info = stateInfo[ state ];
	
	if ( undefined == info ) return;
	
	if ( undefined != info.beforevisiblefn ) {
	
		info.beforevisiblefn();
		
	}
	
	var bHide = ('hidden' == vis);
		
	var items = info.items;
	
	for ( var i = items.length; 0 <= --i; ) {
	
		SetItemVisibility( items[ i ], vis );
		
	}
	
	// manage the display state of the controlling divs
	
	var divs = info.divs;
	
	for ( var i = divs.length; 0 <= --i; ) {
	
		SetElementsVisibility( divs[ i ], vis );
		
	}
	
	// check for specific visibility exclusive
	
	for ( var v in info.visible ) {
	
		SetItemVisibility( v, info.visible[v] ? vis : 'hidden' );
	
	}
	
	for ( var a in info.anims ) {
	
		ActivateAnimation( info.anims[ a ], !bHide );
	
	}

}

// ---------------------------------------------------------------

function StateExists( state ) {
	return stateInfo.hasOwnProperty( state );
}

function RedirectStateToExistingState( target, source ) {
	if ( StateExists( source ) ) {
		stateInfo[target] = stateInfo[source];
	}
}

function ChangeState( state ) {

	if ( activeState == state ) return;
	
	$('#loading_indicator').show();
	
	//ChangeMsg( state );
	
	if ( "" != activeState ) {
	
		SetStateVisibility( activeState, 'hidden' );
		
	}
	
	lastActiveState = activeState;
	
	activeState = state;
	
	SetStateVisibility( activeState, 'visible' );
	
	$('#loading_indicator').hide();
	
	NimbusGames_send_host_message( "state=" + activeState );
}

function HideAllStates() {

	for ( var state in stateInfo ) {
	
		SetStateVisibility( state, 'hidden' );
	
	}

}

// ------------------------------------------------------------------------

function DetermineTruth( truthyOrFalse ) {

	if ( 'boolean' == typeof truthyOrFalse ) return (false != truthyOrFalse);
	
	return !('false' == truthyOrFalse);
}

function SetContextInformation( context, truthyOrFalse ) {

	if ( undefined == context ) return;

	var contextHolders = $( '.' + context );
	
	if ( (undefined == contextHolders) && (0 == contextHolders.length) ) return;
	
	var context_truth_class = context + '_true';
	
	if ( DetermineTruth(truthyOrFalse) ) {
	
		contextHolders.addClass( context_truth_class );
	
	} else {

		contextHolders.removeClass( context_truth_class );
	
	}

}

function EnableContext( context, bEnable ) {
	SetContextAsDisabled( context, !DetermineTruth(bEnable) );
}

function SetContextAsDisabled( context, bDisabled ) {

	if ( undefined == context ) return;

	var contextHolders = $( '.' + context );
	
	if ( (undefined == contextHolders) && (0 == contextHolders.length) ) return;
	
	var context_disabled_class = '_disabled';
	
	if ( DetermineTruth(bDisabled) ) {
	
		contextHolders.addClass( context_disabled_class );
	
	} else {

		contextHolders.removeClass( context_disabled_class );
	
	}

}
// -------------------------------------------------------

var old_id_to_context = {

	"op_skip_check" : "_skip"
,	"op_game_center_check" : "_game_center"
,	"op_text_check" : "_text"
,	"op_music_check" : "_music"
,	"op_messages_check": "_messages"
,	"op_disable_iap_check" : "_disable_iap"
,	"op_stretch_check" : "_stretch"
,	"op_fullscreen_check" : "_fullscreen"

};

function TranslateIDToContext(id) {

	if ( old_id_to_context.hasOwnProperty( id ) ) return old_id_to_context[id];
	
	return undefined;
}

function PMCheck( id, bChecked ) {

	bChecked = DetermineTruth( bChecked );

	var context = TranslateIDToContext(id);

	SetContextInformation( context, bChecked );
	
}

function PMShow( id, bShow ) {

	bShow = DetermineTruth( bShow );
	
	if ( 'mm_unlock_now' == id ) {
	
		SetContextInformation( '_locked', bShow );
		SetContextInformation( '_unlocked', !bShow );
	
	}
}

// -------------------------------------------------------

/* these need to be styles!!! */

var checkbox_ids = [
	"op_skip"
,	"op_game_center"
,	"op_text"
,	"op_music"
,	"op_disable_iap"
,	"op_fullscreen"
,	"op_stretch"
,	"pw_disable_iap"
];

var button_ids = [
	"restart_yes"
,	"restart_no"
,	"pm_home"
,	"pm_options"
,	"pm_main_menu"
,	"pm_play_now"
,	"mm_options"
,	"mm_more_games"
,	"mm_newsletter"
,	"mm_tellafriend"
,	"mm_like"
,	"mm_unlock_now"
,	"mm_play_now"
,	"mm_ads"
,	"mm_more"
,	"op_restart"
,	"op_help"
,	"op_support"
,	"op_home"
,	"op_version"
,	"op_terms"
,	"op_privacy"
,	"op_restore_purchase"
,	"op_messages"
,	"op_more"
,	"pw_home"
,	"pw_unlock_now"
,	"pw_already_purchased"
,	"thumbnail_left"
,	"thumbnail_center"
,	"thumbnail_right"
,	"ri_home"
,	"ri_rate_it_now"
,	"zoom_back"
,	"zoom_left"
,	"zoom_center"
,	"zoom_right"
,	"help_home"
,	"help_prev"
,	"help_next"
,	"toc_sammy_section"
,	"toc_masai_section"
,	"toc_zanzibar_section"
,	"toc_skeeter_section"
,	"toc_jambo_section"
,	"toc_kenya_section"
,	"toc_game_start_section"
,	"pc_play_now"
,	"pc_menu_options"
,	"pc_menu_load"
,	"pc_menu_save"
,	"pc_quit_game"
,   "up_homepj1"
,   "up_homepp1"
,   "up_homepp2"
,   "up_homeff1"
,   "up_homeff2"
,   "up_homesf1"
,	"up_home"
,	"up_pp1right_icon",
,	"up_pp2left_icon",
,	"up_ff1right_icon",
,	"up_ff2left_icon",
,	"up_pp1_icon"
,	"up_pp2_icon"
,	"up_pp3_icon"
,	"up_pp4_icon"
,	"up_pp5_icon"
,	"up_pp6_icon"
,	"up_ppfh_icon"
,	"up_pp_bottom"
,	"up_pppj_bottom"
,	"up_ppff1_bottom"
,	"up_ppff2_bottom"
,	"up_ppsf_bottom"
,	"up_ff1_icon"
,	"up_ff2_icon"
,	"up_ff3_icon"
,	"up_ff4_icon"
,	"up_ff5_icon"
,	"up_ffm1_icon"
,	"up_fffh_icon"
,	"up_ff_bottom"
,	"up_ffpj_bottom"
,	"up_ffpp1_bottom"
,	"up_ffpp2_bottom"
,	"up_ffsf_bottom"
,	"up_pj1_icon"
,	"up_pj2_icon"
,	"up_pj3_icon"
,	"up_pj_bottom"
,	"up_pjpp1_bottom"
,	"up_pjpp2_bottom"
,	"up_pjff1_bottom"
,	"up_pjff2_bottom"
,	"up_pjsf_bottom"
,	"up_sf1_icon"
,	"up_sf2_icon"
,	"up_sf3_icon"
,	"up_sf_bottom"
,	"up_sfpj_bottom"
,	"up_sfpp1_bottom"
,	"up_sfpp2_bottom"
,	"up_sfff1_bottom"
,	"up_sfff2_bottom"
,	"up_nimbus_logo"
,	"confirm_yes"
,	"confirm_no"
,   "confirm_key_gfx_0"
,	"confirm_key_gfx_9"
,	"confirm_key_gfx_8"
,	"confirm_key_gfx_7"
,	"confirm_key_gfx_6"
,	"confirm_key_gfx_5"
,	"confirm_key_gfx_4"
,	"confirm_key_gfx_3"
,	"confirm_key_gfx_2"
,	"confirm_key_gfx_1"
,	"op_nimbus_logo_privacy_policy"
,	"pp_home"
];

// -------------------------------------------------------

function Action( action, actionVisibilityOwner ) {

	if ( undefined != actionVisibilityOwner ) {
	
		var e = document.getElementById( actionVisibilityOwner );
		
		if ( undefined != e ) {
	
			if ( 'hidden' == e.style.visibility ) {
			
				NimbusGames_send_host_message( "skipping=" + action );
				return;
				
			}
			
		}
	
	}
	// Android : send action
	//app.makeToast("action=" + action,false);
    lastAction = action;
	if (action=='mm_play_now')
	{
		//app.makeToast(action,false);
	}
	
	NimbusGames_send_host_message( "action=" + action );
}

// I'm sure there is an existing idiom for this...

function TransferClassToSelector( selector, classname ) {

	$('.'+classname).removeClass(classname);
	$(selector).addClass(classname);

}

function Dispatch( who ) {

	var sel = "#" + who.id;
	
	if ( $(sel).hasClass( "_disabled" ) ) {
		return;
	}
	
	TransferClassToSelector( sel, '_last_dispatch' );

	if ( $(sel).hasClass( "_state_changer" ) ) {
	
		var where = $(sel).attr('_to_');
		
		if ( where ) {
		
			ChangeState( where );
	
			return;
			
		}
	
	}

	Action( who.id, who.parentNode.id );
}

// -------------------------------------------------------

function AttachInputEventHandlers( element, fn ) {
	
	if ( 'IMG' == element.tagName ) {
		
		$(element).addClass('_interactive');
		
	}
	
	$('img',$(element)).addClass('_interactive');

	element.addEventListener(('ontouchend' in window) ? 'touchend': 'click', fn, false );

}

function SetupButton( id ) {

	if ( undefined != document.getElementById( id ) ) {
	
		AttachInputEventHandlers(
			document.getElementById( id ),
			function() {
				Dispatch( document.getElementById( id ) );
			} );
		
	}

}

function SetupCheckbox( id ) {

	SetupButton( id );
	
	// other actions specific to checkboxes

}

function SetupInteractiveElements() {

	for ( var b in button_ids ) {
		SetupButton( button_ids[b] );
	}

	for ( var c in checkbox_ids ) {
		SetupCheckbox( checkbox_ids[c] );
	}
	
	// ---------------------------------------------------
	
	$("._state_changer").each( function( i, changer ) {
	
		SetupButton( $(changer).attr('id') );
	
	});
	
	// ---------------------------------------------------

}

// -------------------------------------------------------

var help_navigation_info = { page_to_name:[], name_to_page:{} };

function PrevHelpPageFrom( current ) {

	// TODO
	// on invalid reference it really should take them to the TOC (once that exists)
	
	if ( !help_navigation_info.name_to_page.hasOwnProperty( current ) ) {
	
		return help_navigation_info.page_to_name[ 0 ];
	
	}
	
	var index = help_navigation_info.name_to_page[ current ] - 1;
	
	if ( 0 > index ) {
	
		index = help_navigation_info.page_to_name.length - 1;
		
		return "_toc_elements";
		
	}
	
	return help_navigation_info.page_to_name[ index ];

}

function NextHelpPageFrom( current ) {

	if ( !help_navigation_info.name_to_page.hasOwnProperty( current ) ) {
	
		return help_navigation_info.page_to_name[ 0 ];
	
	}
	
	var index = help_navigation_info.name_to_page[ current ] + 1;
	
	if ( help_navigation_info.page_to_name.length <= index ) {
	
		index = 0;
		
		return "_toc_elements";
		
	}
	
	return help_navigation_info.page_to_name[ index ];
}

// -------------------------------------------------------

function AddHelpPagesToAvailableStates() {

	var sections = $("._section_container");
	
	sections.each( function( i, section ) {
	
		section = $(section);
	
		var pages = $("._section_page",section);
		
		var section_div_id = "" + section.attr('id');
		
		var section_items = [ "help_navigation_buttons", section_div_id ]
		
		$("._section_header",section).each( function( i, item ) {
		
			item = $(item);
		
			section_items.push( "" + item.attr('id') );
			
		});
		
		pages.each( function( i, page ) {
		
			page = $(page);
		
			var page_id = "" + page.attr('id');
			
			var info = stateInfo[ page_id ] = {};
			
			info.divs = [
				"help_elements"
			,	"help_navigation_buttons"
			,	"help_page_banner"
			,	"help_bg_elements"
			,	page_id
			];
			
			info.items = [
				page_id
			,	"help_navigation_buttons"
			,	"help_page_banner"
			,	"help_bg_elements"
			];
			
			$.each( section_items, function() { info.items.push( this ); });
			
		});
		
	});
	
}

// -------------------------------------------------------

function BuildHelpNavigationTables() {

	$("._section_page").each( function( i, item ) {
		help_navigation_info.page_to_name.push( "" + $(item).attr('id') );
	});
	
	help_navigation_info.page_to_name.sort();
	
	for ( var i in help_navigation_info.page_to_name ) {
	
		help_navigation_info.name_to_page[ help_navigation_info.page_to_name[ i ] ] = parseInt(i);
	
	}
}

// -------------------------------------------------------

function SetStateChangeInfoForSelector( sel, state ) {

	$(sel).addClass( '_state_changer' );
	$(sel).attr('_to_', state );

}

function MakeSeperatePagesForPanels( holder, combined_page ) {

	var page_id = $(combined_page).attr('id');
	
	$("._section_panels", combined_page ).each( function( i, panel ) {
	
		$( $(panel).children() ).each( function( i, content ) {
	
			var content_id = $(content).attr('id');
		
			var sub_page = $("<div>")
				.attr('id', '_zoom' + content_id + '_elements')
				.attr('class', $(combined_page).attr('class') )
				;
				
			sub_page.appendTo( $(holder) );
			
			var sub_panel_holder = $("<div>")
				.attr('id', content_id + '_panels')
				.attr('class', $(panel).attr('class') )
				;

			SetStateChangeInfoForSelector( $(sub_panel_holder), page_id );
			
			SetStateChangeInfoForSelector( $(content), $(sub_page).attr('id') );
				
			$(sub_panel_holder).appendTo( $(sub_page) );
			
			var clo = $(content).clone(); // what about data???
			
			$(clo).attr('id', $(clo).attr('id') + '_');
			
			$(clo).removeClass( content_id + '_position' );
			$(clo).removeClass( content_id + '_p' );
			
			$(clo).addClass( 'zoomed_and_centered_panel' );
			
			// reposition it
			
			$(clo).appendTo( $(sub_panel_holder) );
				
		});
	
	});

}

function AddAlternativeHelpLayouts()
{
	var all_sections = $("._section_container", $("#help_elements") );
	
	$(all_sections).each( function( idx, section ) {
	
		var section_id = $(section).attr('id');
	
		var section_pages = $("._section_page", $(section) );
		
		var holder = $("<div>").attr('id',section_id + '_panels_as_seperate_pages');
		
		holder.appendTo( $(section) );
		
		$(section_pages).each( function( i, combined_page ) {
		
			MakeSeperatePagesForPanels( holder, combined_page );
			
		});
	
	});

}

// -------------------------------------------------------

function SetupHelpPages() {

	// now make the alternative layout
	
	AddAlternativeHelpLayouts();
	
	// link them up
	
	BuildHelpNavigationTables();
	
	// now put them so they can be accessed :)
	
	AddHelpPagesToAvailableStates();
	
}

// -------------------------------------------------------

function SetupButterflyAnim( holder, placeholder, prefix, framesArray ) {

	holder = $('#' + holder);
	
	placeholder = $('#' + placeholder);
	
	for ( var i = 1; i <= 22; ++i ) {
	
		var clone = placeholder.clone();
		
		var tens = Math.floor( i / 10 ) % 10;
		var ones = i % 10;
		
		clone.attr('_src_', 'bf/bf_' + tens + '' + ones + '.png' );
		
		var id = prefix + tens + '' + ones;
		
		clone.attr('id', id );
		
		clone.appendTo( holder );
		
		framesArray[ i - 1 ] = id;
	
	}

	placeholder.remove();
}

function AddAnimationFramesToPlaceholders() {

	SetupButterflyAnim( 'ri_anim_holder', 'menu_ri_anim', 'ri_bf_', ri_butterfly_frames );
	SetupButterflyAnim( 'pw_anim_holder', 'menu_pw_anim', 'pw_bf_', pw_butterfly_frames );
	SetupButterflyAnim( 'pm_anim_holder', 'menu_pm_anim', 'pm_bf_', pm_butterfly_frames );
	SetupButterflyAnim( 'mm_play_anim', 'menu_mm_play_anim', 'm1_bf_', m1_butterfly_frames );
	SetupButterflyAnim( 'mm_unlock_anim', 'mm_unlock_anim_2', 'm2_bf_', m2_butterfly_frames );
	SetupButterflyAnim( 'pc_play_anim_holder', 'menu_pc_play_anim', 'pc_bf_', pc_butterfly_frames );
	
}

// -------------------------------------------------------

function noop_event_handler(event) {

	if ( "_privacy" != activeState ) {

		event.preventDefault();
		
	}
	
}

function drag_event_handler(event) {

	if ( "_privacy" != activeState ) {

		event.preventDefault();
		
	}
}

$(document).ready(function() {

	document.body.addEventListener('touchmove', noop_event_handler, false );
	document.body.addEventListener('gesturestart', noop_event_handler, false );
	document.body.addEventListener('gesturechange', noop_event_handler, false );
	document.body.addEventListener('gestureend', noop_event_handler, false );
	
	document.body.addEventListener('ondragstart', drag_event_handler, true );
	document.body.addEventListener('ondrag', drag_event_handler, true );
	document.body.addEventListener('ondragend', drag_event_handler, true );

//	SetupHelpPages();
//	AddAnimationFramesToPlaceholders();
	
//	HideAllStates();
//	ChangeLoadedStateForThese( $('#menu_elements') , true, '._preload_' );

});

// ----------------------------------------------------------------------------

function TESTING_PC(blocked) {
	
	RedirectStateToExistingState('_menu','_pc_menu'); // Aric the PC needs call this :)

	SetContextInformation('_has_terms',false);
	SetContextInformation('_has_privacy',false);
	SetContextInformation('_has_support',false);
	SetContextInformation('_show_version',false);
	
	SetContextInformation('_has_stretch',false);
	EnableContext('_has_stretch', false);
	
	SetContextInformation('_has_fullscreen',true);
	EnableContext('_has_fullscreen', false);
	
	SetContextInformation('_has_quit_button',true);
	SetContextInformation('_user_has_not_tapped_rating',true);

	SetContextInformation('_has_game_center',false);
	SetContextInformation('_push',false);
	SetContextInformation('_disable_iap',!blocked);
	SetContextInformation('_iap_enabled',blocked);
	SetContextInformation('_unlocked',(!blocked));
	SetContextInformation('_locked',blocked);
	
	SetContextInformation('_has_save', true);
	EnableContext('_has_save', false);
	
	SetContextInformation('_has_load', true);
	EnableContext('_has_load', false);
	
	ChangeState("_splash");
	
	//code
}

function TESTING_iOS( blocked ) {
	
	SetContextInformation('_has_terms',true);
	SetContextInformation('_has_privacy',true);
	SetContextInformation('_has_support',true);
	SetContextInformation('_show_version',true);
	
	SetContextInformation('_has_stretch',false);
	SetContextInformation('_has_fullscreen',false);
	SetContextInformation('_has_quit_button',false);
	SetContextInformation('_user_has_not_tapped_rating',true);

	SetContextInformation('_has_game_center',true);
	SetContextInformation('_push',false);
	SetContextInformation('_unlocked',(!blocked));
	SetContextInformation('_locked',blocked);
	
	SetContextInformation('_disable_iap',false);
	SetContextInformation('_iap_enabled',blocked);
	
//	ChangeState("_splash"); // ChangeState("_menu");
}

// ----------------------------------------------------------------------------

var version_element_holders = [ "op_version", "pm_version", "pc_menu_version" ];

function SetVersionDescription(description) {
	
	for (var i in version_element_holders ) {
		
		var id = version_element_holders[ i ];
		
		var e = document.getElementById( id );
	
		if (null != e) {
			
			e.outerHTML =
				"<div id='"
			+	id
			+	"' class='"
			+	id + "_p"
			+	"' style='position:absolute; display:block;'><div style='text-align:center;'><span><b>Version:"
			+	description
			+	"</b></span></div></div>";
			
		}	
	}
	
}

function getActiveState() {
   // alert(activeState);
    return lastAction;//activeState;
}


// ----------------------------------------------------------------------------

$(window).load(function() {

	NimbusGames_send_host_message("status=menu_is_finally_ready");

	SetupInteractiveElements();
	
	setInterval( PerformAnimations, 100 );
	
//	ChangeLoadedStateForThese( $('#container') , true, '._preload_' );
	
	NimbusGames_send_host_message("status=menu_has_been_kickstarted");
	
/*
	if ( !IsRunningInsideCallbackHost() ) {
	
		//TESTING_PC(false);
		//TESTING_iOS(false);
	
	}
*/
	
});
